$NOFLOATCALLS
C***********************************************************************
C
      SUBROUTINE MTABL
C
C***********************************************************************
C
C             -- THE SUMMARY TABLE REPORT WRITER MODULE --
C
C THIS SUBROUTINE PRINTS ENERGY PRICE AND QUANTITY VALUES FOR ALL
C PERIODS BY REGION AND BY FUEL TYPE ACCORDING TO THE OUTPUT
C OPTION SPECIFICATIONS.
C
C INTEGER INPUTS: M, NF, NFF, NI, NJ, NKKL, NKKMAX, NL
C
C REAL INPUTS:    CONLM, CONM, CO2IM, CO2LM, CO2M, EDIM, EDLM, EDM,
C                 EDRKLM, EDRKM, EDRLM, EDRM, EDRIM, EFIM, EFLM, EFM,
C                 EPCLM, EPCM, EPGLM, EPGM, ESIL1M, ESI1M, ESIL2M,
C                 ESI2M, ESRILM, ESRIM, ESIM, ESLM, ESM, ESRLM, ESRM,
C                 ESULIM, ESULM, ESUM, EXIM, EXLM, EXM, SYNIM, SYNLM,
C                 SYNM,CH4LM,CH4M
C
C SUBROUTINES CALLED: NONE
C
C WRITTEN BY DAN WAHL
C LATEST REVISION: 6 SEPT 1988
C NATURE OF REVISION:COMMON 'INCLUDED' & METHANE DATA INCORPORATED
C
C***********************************************************************
C
C  MAKE ALL REAL VARIABLES DOUBLE PRECISION
C
      IMPLICIT   REAL*8 (A-H,O-Z),   INTEGER (I-N)
C
C COMMON BLOCKS
$INCLUDE:'COMMON.FOR'
C
C--LOCAL PARAMETERS
C
      INTEGER R(30)
C
      R(1)='USA '
      R(2)='    '
      R(3)='    '
      R(4)='CANA'
      R(5)='DA &'
      R(6)=' EUR'
      R(7)='OECD'
      R(8)=' PAC'
      R(9)='IFIC'
      R(10)='USSR'
      R(11)='/E. '
      R(12)='EUR.'
      R(13)='CHIN'
      R(14)='A/ET'
      R(15)='.AL.'
      R(16)='MIDD'
      R(17)='LE E'
      R(18)='AST '
      R(19)='AFRI'
      R(20)='CA  '
      R(21)='    '
      R(22)='LATI'
      R(23)='N AM'
      R(24)='ER  '
      R(25)='S.&E'
      R(26)='. AS'
      R(27)='IA  '
      R(28)='ALL '
      R(29)='REGI'
      R(30)='ONS '
C
C   +-------------------------------+
C   |   COLLECT FORMAT STATEMENTS   |
C   +-------------------------------+
C
 2000 FORMAT (1H1)
 2006 FORMAT (1X,31X,'(UNITS=EXAJOULES (J*10**18))')
 2010 FORMAT (1X)
 2021 FORMAT (1H0)
 2025 FORMAT (1X,25X,I4,' ENERGY PRODUCTION AND USAGE REPORT'/
     &       1X,25X,39('*')/)
 2100 FORMAT(1H1,22X,'SUMMARY ENERGY PRODUCTION AND USAGE REPORT'/1X,
     &22X,42('*')/)
 2101 FORMAT(1X,28X,'EXAJOULES(J*10**18) PER CAPITA')
 2102 FORMAT(1X,23X,'EXAJOULES(J*10**18) PER 1975 US DOLLAR GNP')
 2103 FORMAT(1X,29X,'UNITS=10**6 TONS OF CARBON')
 2104 FORMAT(1X,29X,'UNITS=10**6 TONS OF METHANE')
 2105 FORMAT(1X,21X,'PRIMARY ENERGY DEMAND, BY REGION AND PERIOD')
 2110 FORMAT(1X,23X,'1975      2000      2025      2050      2075      2
     &100')
 2115 FORMAT(1X,20X,6(' -------- '))
 2120 FORMAT(1X,3A4,8X,6(F8.2,2X))
 2125 FORMAT(1X,21X,'PRIMARY ENERGY SUPPLY, BY REGION AND PERIOD')
 2130 FORMAT(1X,20X,'SECONDARY ENERGY DEMAND, BY REGION AND PERIOD')
 2135 FORMAT(1X,14X,'CONSERVATION AND NON-ELECTRIC SOLAR, BY',
     &' REGION AND PERIOD')
 2140 FORMAT(1X,20X,'REFINABLE ENERGY DEMAND, BY REGION AND PERIOD')
 2145 FORMAT(1X,20X,'REFINABLE ENERGY SUPPLY, BY REGION AND PERIOD')
 2150 FORMAT(1X,20X,'REFINABLE OIL SUPPLY, BY REGION AND PERIOD')
 2155 FORMAT(1X,20X,'REFINABLE CONVENTIONAL OIL SUPPLY, BY REGION AND PE
     &RIOD')
 2160 FORMAT(1X,20X,'REFINABLE UNCONVENTIONAL OIL SUPPLY, BY REGION AND
     &PERIOD')
 2165 FORMAT(1X,20X,'REFINABLE SYNOIL SUPPLY, BY REGION AND PERIOD')
 2170 FORMAT(1X,20X,'REFINABLE GAS SUPPLY, BY REGION AND PERIOD')
 2175 FORMAT(1X,20X,'REFINABLE CONVENTIONAL GAS SUPPLY BY REGION AND PER
     &IOD')
 2180 FORMAT(1X,17X,'REFINABLE UNCONVENTIONAL GAS SUPPLY BY REGION AND P
     &ERIOD')
 2185 FORMAT(1X,20X,'REFINABLE SYNGAS SUPPLY, BY REGION AND PERIOD')
 2190 FORMAT(1X,20X,'REFINABLE SOLIDS SUPPLY, BY REGION AND PERIOD')
 2195 FORMAT(1X,25X,'REFINABLE COAL SUPPLY, BY REGION AND PERIOD')
 2200 FORMAT(1X,25X,'REFINABLE BIOMASS SUPPLY, BY REGION AND PERIOD')
 2205 FORMAT(1X,25X,'NET ENERGY IMPORTS, BY REGION AND PERIOD')
 2210 FORMAT(1X,25X,'ELECTRICITY DEMAND, BY REGION AND PERIOD')
 2215 FORMAT(1X,25X,'ELECTRICITY SUPPLY, BY REGION AND PERIOD')
 2220 FORMAT(1X,20X,'SYNFUEL PRODUCTION, BY REGION AND PERIOD')
 2225 FORMAT(1X,20X,'COAL CONSUMED IN SYNFUEL PRODUCTION, BY REGION AND
     &PERIOD')
 2230 FORMAT(1X,20X,'ENERGY USE PER CAPITA, BY REGION AND PERIOD')
 2235 FORMAT(1X,20X,'ENERGY USE PER DOLLAR GNP, BY REGION AND PERIOD')
 2240 FORMAT(1X,23X,'CARBON EMISSIONS, BY REGION AND PERIOD')
 2245 FORMAT(1X,20X,'ENERGY USE PER DOLLAR GNP')
 2250 FORMAT(1X,23X,'METHANE EMISSIONS, BY REGION AND PERIOD')
C
C
C--SET INTERNAL CONTROL PARAMETERS
C
      NKD=NKKMAX+1
      NKS=NKD+1
      NKX=NKS+1
      NLL=NL+1
      NYR=1950+NJUMP*M
      NNF=NF+1
      LC=1+3*(NL)
      LD=LC+2
      LE=1+3*(NLL)
      LF=LE+2
      KC=1+5*NKKMAX
      KD=KC+4
      KE=1+5*NKD
      KF=KE+4
C
C         +-----------------------------------------+
C         |   SUMMARY TABLES, BY REGION AND PERIOD  |
C         +-----------------------------------------+
C
C   +-------------------------------------------+
C   |   SUMMARY OF ENERGY USE(DEMAND) PATTERN   |
C   +-------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2105)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 120 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EDLM(L,M),M=1,NM)
  120 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EDM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +-----------------------------------------------------------+
C   |   WRITE OUT SUPPLY PATTERN SUMMARY, BY REGION AND PERIOD  |
C   +-----------------------------------------------------------+
C
      WRITE(JUNIT,2125)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 130 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESLM(L,M),M=1,NM)
 130  CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C  +-----------------------------------------------------------------+
C  | WRITE OUT SECONDARY ENERGY DEMAND SUMMARY, BY REGION AND PERIOD |
C  +-----------------------------------------------------------------+
C
      WRITE(JUNIT,2130)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 140 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EFLM(L,M),M=1,NM)
  140 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EFM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C  +----------------------------------------------+
C  |  CONSERVATION AND NON-ELECTRIC SOLAR SUMMARY |
C  +----------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2135)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 150 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(CONLM(L,M),M=1,NM)
  150 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(CONM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +---------------------------------------------------+
C   |   WRITE OUT REFINABLE ENERGY DEMAND SUMMARY       |
C   +---------------------------------------------------+
C
      WRITE(JUNIT,2140)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 160 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EDRLM(L,M),M=1,NM)
  160 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EDRM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +-----------------------------------------------+
C   |   WRITE OUT REFINABLE ENERGY SUPPLY SUMMARY   |
C   +-----------------------------------------------+
C
      WRITE(JUNIT,2145)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 170 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRLM(L,M),M=1,NM)
  170 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESRM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +--------------------------------------------+
C   |   WRITE OUT REFINABLE OIL SUPPLY SUMMARY   |
C   +-------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2150)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 180 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRILM(1,L,M),M=1,NM)
  180 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESRIM(1,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------+
C   |   REFINABLE CONVENTIONAL OIL SUPPLY SUMMARY  |
C   +---------------------------------------------+
C
      WRITE(JUNIT,2155)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 190 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESIL1M(1,L,M),M=1,NM)
  190 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESI1M(1,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +------------------------------------------------+
C   |   REFINABLE UNCONVENTIONAL OIL SUPPLY SUMMARY  |
C   +------------------------------------------------+
C
      WRITE(JUNIT,2160)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 200 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESIL2M(1,L,M),M=1,NM)
  200 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESI2M(1,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------+
C   |   WRITE OUT REFINABLE SYNOIL SUPPLY SUMMARY  |
C   +----------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2165)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 210 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(SYNILM(1,L,M),M=1,NM)
  210 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(SYNIM(1,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +----------------------------------+
C   |   REFINABLE GAS SUPPLY SUMMARY   |
C   +----------------------------------+
C
      WRITE(JUNIT,2170)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 220 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRILM(2,L,M),M=1,NM)
  220 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESRIM(2,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------+
C   |   REFINABLE CONVENTIONAL GAS SUPPLY SUMMARY  |
C   +----------------------------------------------+
C
      WRITE(JUNIT,2175)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 230 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESIL1M(2,L,M),M=1,NM)
  230 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESI1M(2,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +------------------------------------------------+
C   |   REFINABLE UNCONVENTIONAL GAS SUPPLY SUMMARY  |
C   +------------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2180)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 240 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESIL2M(2,L,M),M=1,NM)
  240 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESI2M(2,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------+
C   |   WRITE OUT REFINABLE SYNGAS SUPPLY SUMMARY  |
C   +----------------------------------------------+
C
      WRITE(JUNIT,2185)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 250 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(SYNILM(2,L,M),M=1,NM)
  250 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(SYNIM(2,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +---------------------------------------------+
C   | WRITE OUT REFINABLE SOLIDS SUPPLY SUMMARY   |
C   +---------------------------------------------+
C
      WRITE(JUNIT,2190)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 260 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRILM(3,L,M),M=1,NM)
  260 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESRIM(3,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +--------------------------------------------+
C   |   WRITE OUT REFINABLE COAL SUPPLY SUMMARY  |
C   +--------------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2195)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 270 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRL1M(L,M),M=1,NM)
  270 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JIUNIT,2120)   (R(LL),LL=LC,LD),(ESR1M(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +-----------------------------------------------+
C   |   WRITE OUT REFINABLE BIOMASS SUPPLY SUMMARY  |
C   +-----------------------------------------------+
C
      WRITE(JUNIT,2200)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 280 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESRL2M(L,M),M=1,NM)
  280 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESR2M(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C      --------------------------------------------
C      --  WRITE OUT SYNFUEL PRODUCTION SUMMARY  --
C      --------------------------------------------
C
      WRITE(JUNIT,2220)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 285 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(SYNLM(L,M),M=1,NM)
  285 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(SYNM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C      +---------------------------------------+
C      |  COAL CONSUMED IN SYNFUEL PRODUCTION  |
C      +---------------------------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2225)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 290 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(SYNILM(NF,L,M),M=1,NM)
  290 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(SYNIM(NF,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +------------------------------------------+
C   |   WRITE OUT NET ENERGY IMPORTS SUMMARY   |
C   +------------------------------------------+
C
      WRITE(JUNIT,2205)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 295 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EXLM(L,M),M=1,NM)
  295 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EXM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C   +------------------------------------------+
C   |   WRITE OUT ELECTRICITY DEMAND SUMMARY   |
C   +------------------------------------------+
C
      WRITE(JUNIT,2210)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 300 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EDRKLM(1,L,M),M=1,NM)
  300 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EDRKM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C      --------------------------------------------
C     --  WRITE OUT ELECTRICITY SUPPLY SUMMARY  --
C      --------------------------------------------
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2215)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 310 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(ESULM(L,M),M=1,NM)
  310 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(ESUM(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C        +-------------------------------------------+
C        |  WRITE OUT ENERGY USE PER CAPITA SUMMARY  |
C        +-------------------------------------------+
C
      WRITE(JUNIT,2230)
      WRITE(JUNIT,2101)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 320 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EPCLM(L,M),M=1,NM)
  320 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EPCLM(10,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C        +-----------------------------------------------+
C        |  WRITE OUT ENERGY USE PER DOLLAR GNP SUMMARY  |
C        +-----------------------------------------------+
C
      WRITE(JUNIT,2235)
      WRITE(JUNIT,2102)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 330 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(EPGLM(L,M),M=1,NM)
  330 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(EPGLM(10,M),M=1,NM)
      WRITE(JUNIT,2021)
C
C        +--------------------+
C        |  CARBON EMISSIONS  |
C        +--------------------+
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2240)
      WRITE(JUNIT,2103)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 340 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2120)   (R(LL),LL=LA,LB),(CO2LM(L,M),M=1,NM)
  340 CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)   (R(LL),LL=LC,LD),(CO2M(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C         +---------------------------------+
C         |      METHANE EMISSIONS          |
C         +---------------------------------+
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2250)
      WRITE(JUNIT,2104)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2110)
      WRITE(JUNIT,2115)
      DO 350 L=1,NL
          LA=1+3*(L-1)
          LB=LA+2
          WRITE(JUNIT,2120) (R(LL),LL=LA,LB),(CH4LM(L,M),M=1,NM)
 350  CONTINUE
      WRITE(JUNIT,2115)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2120)  (R(LL),LL=LC,LD),(CH4M(M),M=1,NM)
      WRITE(JUNIT,2021)
C
C     --  RETURN TO THE MAIN PROGRAM  --
C
335   CONTINUE
      RETURN
      END
