$NOFLOATCALLS
C***********************************************************************
C
      SUBROUTINE   NSET
C
C***********************************************************************
C
C         -- THE PROGRAM CONTROL PARAMETER SUBROUTINE --
C
C THIS SUBROUTINE SETS VALUES FOR THE PROGRAM CONTROL PARAMETERS.
C
C MODEL VERSION:  A.07.31.84
C
C
C INTEGER OUTPUTS: MAXAGN, NCO2, NF, NFF, NI, NIG, NIM, NIP, NIS, NJ,
C                  NJUMP, NKKL, NKL, NKMAX, NKKMAX, NL, NMREAD, NMKT,
C                  NOPT, NU
C
C REAL OUTPUT:     TEST
C
C     SUBROUTINES CALLED: NONE
C
C     CODED BY:
C       JAE EDMONDS                    LATEST REVISION:
C       1 JANUARY 1982                  8 JULY 1984
C
C***********************************************************************
C
C  MAKE ALL REAL VARIABLES DOUBLE PRECISION
C
      IMPLICIT   REAL*8 (A-H,O-Z),   INTEGER (I-N)
C
C COMMON BLOCKS
$INCLUDE:'COMMON.FOR'
C
C    LOCAL VARIABLES:  A, A1, A2, R
C
      INTEGER R(27)
C
      DIMENSION A(20),A1(7),A2(7)
C
      R(1)='USA '
      R(2)='    '
      R(3)='    '
      R(4)='CANA'
      R(5)='DA &'
      R(6)=' EUR'
      R(7)='OECD'
      R(8)=' PAC'
      R(9)='IFIC'
      R(10)='USSR'
      R(11)='E/. '
      R(12)='EUR.'
      R(13)='CHIN'
      R(14)='A/ET'
      R(15)='.AL.'
      R(16)='MIDD'
      R(17)='LE E'
      R(18)='AST '
      R(19)='AFRI'
      R(20)='CA  '
      R(21)='    '
      R(22)='LATI'
      R(23)='N AM'
      R(24)='ER  '
      R(25)='S.&E'
      R(26)='. AS'
      R(27)='IA  '
C
C SET THE EXCESS DEMAND LIMIT
      TEST  = .0047D0
C
C
C SET PARAMETER VALUES
C
      MAXAGN= 75
      NCO2  = 8
      NF    = 3
      NFF   = 2
      NI    = 6
      NIG   = 5
      NIM   = 2
      NIP   = 4
      NIS   = 4
      NNIS  = 5
      NJ    = 4
      NJUMP = 25
      NKMAX = 3
      NKKMAX= NKMAX+1
      NL    = 9
      NMREAD= 6
      NMKT  = 3
      NU    = 5
      DO 10 L=1,NL
        NKL(L)=1
        IF (L .LE. 3)    NKL(L)=3
        NKKL(L)=NKL(L)+1
10    CONTINUE
C
C -- OUTPUT OPTION CONTROL
C
      IF(NOPT(1) .EQ. 1)  GO TO 110
C
C  --------------------------------------------
C  --  PRINT THE PROGRAM CONTROL PARAMETERS  --
C  --------------------------------------------
C
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   NFF
      WRITE(JUNIT,2030)   NF
      WRITE(JUNIT,2040)   NI
      WRITE(JUNIT,2045)   NIG
      WRITE(JUNIT,2150)   NIM
      WRITE(JUNIT,2160)   NIP
      WRITE(JUNIT,2165)   NIS
      WRITE(JUNIT,2166)   NNIS
      WRITE(JUNIT,2050)   NJ
      WRITE(JUNIT,2060)   NJUMP
      WRITE(JUNIT,2070)   NKMAX
      WRITE(JUNIT,2080)   NKKMAX
      WRITE(JUNIT,2090)   NL
      WRITE(JUNIT,2100)   NM
      WRITE(JUNIT,2105)   NMREAD
      WRITE(JUNIT,2140)   NMKT
      WRITE(JUNIT,2110)   NU
      WRITE(JUNIT,2170)   NCO2
      WRITE(JUNIT,2180)   MAXAGN
      WRITE(JUNIT,2190)   TEST
      WRITE(JUNIT,2120)
      DO 100 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2130)  (R(LL),LL=LA,LB),NKL(L),NKKL(L)
  100 CONTINUE
C
 1100 FORMAT (7A4,I2)
 1200 FORMAT (2(7A4,I2))
 2000 FORMAT(1H1,/////1X,27X,'PROGRAM CONTROL PARAMETERS')
 2010 FORMAT(1H0,23X, '--INITIALIZED IN SUBROUTINE NSET--',//)
 2020 FORMAT(1X, 'NFF   =', I3, 5X, 'NUMBER OF SYNFUELS')
 2030 FORMAT(1X, 'NF    =', I3, 5X, 'NUMBER OF FOSSIL FUELS')
 2040 FORMAT(1X, 'NI    =', I3, 5X, 'NUMBER OF PRIMARY ENERGY TYPES')
 2045 FORMAT(1X, 'NIG   =', I3, 5X, 'NUMBER OF RESOURCE GRADES FOR FOSSI
     &L FUELS AND URANIUM')
 2050 FORMAT(1X, 'NJ    =', I3, 5X, 'NUMBER OF SECONDARY ENERGY TYPES')
 2060 FORMAT(1X, 'NJUMP =', I3, 5X, 'NUMBER OF YEARS BETWEEN PERIODS')
 2070 FORMAT(1X, 'NKMAX =', I3, 5X, 'MAXIMUM NUMBER OF END-USE SECTORS')
 2080 FORMAT(1X, 'NKKMAX=', I3, 5X, 'MAXIMUM NUMBER OF END-USE SECTORS P
     &LUS UTILITIES')
 2090 FORMAT(1X, 'NL    =', I3, 5X, 'NUMBER OF REGIONS')
 2100 FORMAT(1X, 'NM    =', I3, 5X, 'NUMBER OF FORECAST PERIODS')
 2101 FORMAT(1X,7A4,I2)
 2105 FORMAT(1X, 'NMREAD=', I3, 5X, 'NUMBER OF PERIODS READ IN INPUT')
 2110 FORMAT(1X, 'NU    =', I3, 5X, 'NUMBER OF COMPETING FUELS IN ELECTR
     &IC GENERATION')
 2120 FORMAT(1H0,29X,'END USE SECTORS'/
     &1H0,'REGION',9X,'FINAL DEMAND SECTORS',3X,'PLUS UTILITIES')
 2130 FORMAT(1X,3A4,14X,I1,18X,I1)
 2140 FORMAT(1X, 'NMKT  =', I3, 5X, 'NUMBER OF INTERNATIONAL MARKETS')
 2150 FORMAT(1X, 'NIM   =', I3, 5X, 'NUMBER OF BIOMASS TYPES')
 2160 FORMAT(1X, 'NIP   =', I3, 5X, 'NUMBER OF BIOMASS SUPPLY SCHEDULE S
     &EGMENTS')
 2165 FORMAT(1X, 'NIS   =', I3, 5X, 'NUMBER OF RESOURCE CONSTRAINED FUEL
     &S')
 2166 FORMAT(1X, 'NNIS  =', I3, 5X, 'NIS PLUS ONE FOR NUCLEAR POWER')
 2170 FORMAT(1X, 'NC02  =', I3, 5X, 'NUMBER OF CO2 EMISSION CATEGORIES')
 2180 FORMAT(1X, 'MAXAGN=', I3, 5X, 'MAXIMUM NUMBER OF ITERATIONS PER PE
     &RIOD')
 2190 FORMAT(1X, 'TEST  =', F6.4, 2X, 'CONVERGENCE TEST VALUE')
 2200 FORMAT(1X,2(7A4,I2))
 3000 FORMAT(20A4\)
 4000 FORMAT(1X,20A4)
C
  110 CONTINUE
C
      RETURN
      END
