$NOFLOATCALLS
C***********************************************************************
C
      SUBROUTINE OREAD
C
C***********************************************************************
C
C                    -- DATA INPUT MODULE --
C
C THIS SUBROUTINE READS AND PRINTS EXOGENOUS INPUT DATA AND PARAMETER
C VALUES IN THE FOLLOWING ORDER:
C
C   PIM,TRI                STISL                  BSJKLM
C   NXIL,TXILM,TXJLM       BESIL                  RPKK,RPJK
C   ZL,ZLM                 ESFILM                 RPK,RPJ
C   PROLM,GNPBL            FLRL                   RYKK,RYJK
C   GIJ,HIJ                HYDRO                  RYJ,RYKLT
C   GUI,HUIL,RUI           CILT (SOLAR)           RY
C   PAUIL                  HCILT                  COI
C   BSUILM                 GCI,RCI                SBURNL,SHALE
C   TJKLM                  GJK,GJ                 SFEDIL
C   RIGISL                 HJK,HJ                 BIOPSM
C   CIGIS                  SJKLP,BSKL             BIOLM
C   VISL                                          RYSHT
C   DILSET
C   RIL
C
C MODEL VERSION:  A.07.31.84
C
C SUBROUTINES CALLED: NONE
C
C CODED BY: JAE EDMONDS             LATEST REVISION BY: DAN WAHL
C COMPLETED: 1 JANUARY 1982         ON 3 NOVEMBER 1982
C                                   PURPOSE: ADDED VARIABLES BBESIL,
C                                            RSYIL, AND RYSHT.
C
C                                   REVISED BY: JAE EDMONDS
C                                   6 JANUARY 1984
C                                   PURPOSE:  MAJOR MODEL REVISION
C                                     1) REPLACE GNP WITH PROL
C                                        AND CHANGE ZLM TO READ
C                                        IN AS ABSOLUTE POPULATION
C                                        AND REMOVE ZL
C
C                                    8 JULY 1984
C                                        VARIABLES DELETED ARE :
C                                          AIL, BIL, DIL, RESIL,
C                                          EASTIM, CILT, RIL,
C                                          BESILM, DILSET
C                                        VARIABLES ADDED ARE:
C                                          RIGISL, CIGIS, VISL,
C                                          DILSET, RIL, STISL,
C                                          BESIL, ESFILM
C                                 16 SEPTEMBER 1988
C                                       TO READ INPUT TO SUPPORT
C                                       CH4 SUBROUTINE
C***********************************************************************
C
C  MAKE ALL REAL VARIABLES DOUBLE PRECISION
C
      IMPLICIT   REAL*8 (A-H,O-Z),   INTEGER (I-N)
C
C COMMON BLOCKS
C
$INCLUDE:'COMMON.FOR'                                                
C
C  -- DECLARE CHARACTER VARIABLES --
C
      DIMENSION   A(20),NOTES(5),ANOTE(2),NOTE2(5)
C
C
1000  FORMAT (6F10.0,5A4)
1010  FORMAT (3I10,7A4)
1020  FORMAT (4F10.0,7A4)
1026  FORMAT (6F10.0,5A4)
1030  FORMAT (5F10.0,7A4)
1031  FORMAT (7F9.0,2A4)
1040  FORMAT (2F10.0,5A4)
1045  FORMAT (2(5A4,F6.2,4X))
1060  FORMAT (3F10.0,7A4)
1070  FORMAT (6F10.0,5A4)
1080  FORMAT (F10.0,5A4,50X)
1090  FORMAT (F10.0,40X,7A4)
1095  FORMAT (7F10.0,2A4)
1096  FORMAT (5F10.0,2A4)
1100  FORMAT (20A4)
2000  FORMAT (1X,6F10.4,5A4)
2005  FORMAT (1X,6(F8.2,2X),5A4)
2010  FORMAT (1X,3I10,7A4)
2020  FORMAT (1X,4F10.2,7A4)
2025  FORMAT (1X,4(F8.4,2X),7A4)
2026  FORMAT (1X,6(F8.4,2X),5A4)
2030  FORMAT (1X,5F10.4,7A4)
2031  FORMAT (1X,6F9.2,F9.4,2A4)
2032  FORMAT (1X,7F9.0,2A4)
2033  FORMAT (1X,5F10.0,7A4)
2034  FORMAT (1X,5F10.2,7A4)
2040  FORMAT (1X,F10.3,F10.0,7A4)
2042  FORMAT (1X,2(F8.2,2X),7A4)
2045  FORMAT (1X,2(5A4,F6.2,4X))
2060  FORMAT (1X,3F10.4,7A4,20X)
2070  FORMAT (1X,6F10.0,5A4)
2071  FORMAT (1X,6F10.3,5A4)
2080  FORMAT (1X,F10.4,5A4)
2090  FORMAT (1X,F10.4,40X,7A4)
2095  FORMAT (1X,7F10.2,2A4)
2096  FORMAT (1X,7F10.3,2A4)
2097  FORMAT (1X,5F10.3,2A4)
2100  FORMAT (1X,20A4)
2105  FORMAT ('1')
C
C   SET MODEL VERSION NUMBER
       MVRSN = 2
       JUNIT=0
C
      CALL OREAD2
C
C ---------------------------------------------------------------
C --  READ TKL--RATE OF END-USE ENERGY EFFICIENCY IMPROVEMENT  --
C --            BY SECTOR AND REGION                           --
C ---------------------------------------------------------------
C
      DO 130 KK=1,8
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 139,130,139
  139    WRITE(JUNIT,2100)  A
  130 CONTINUE
C
      DO 160 L=1,3
         NK=NKL(L)
         READ (IUNIT,1060)   (TKL(K,L),K=1,NK),NOTES
         IF (NOPT(2)-1) 150,160,150
  150    WRITE(JUNIT,2060)   (TKL(K,L),K=1,NK),NOTES
  160 CONTINUE
C
      DO 180 KK=1,3
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 179,180,179
  179    WRITE(JUNIT,2100)  A
  180 CONTINUE
C
      DO 190 L=4,NL
         NK=NKL(L)
         READ (IUNIT,1080)   (TKL(K,L),K=1,NK),NOTES
         IF (NOPT(2)-1) 189,190,189
  189    WRITE(JUNIT,2080)   (TKL(K,L),K=1,NK),NOTES
  190 CONTINUE
C
C-----------------------------------------------------------------------
C
C
C              READ RIGISL--RESOURCE BASE AMOUNTS
C
      DO 700 KK=1,4
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)   GO TO 700
         WRITE(JUNIT,2100)  A
  700 CONTINUE
C
      DO 710 IG=1,NIG
C
         DO 712 KK=1,4
            READ (IUNIT,1100)   A
            IF (NOPT(2) .EQ. 1)   GO TO 712
            WRITE(JUNIT,2100)   A
  712    CONTINUE
C
         DO 714 L=1,NL
            READ (IUNIT,1030)   (RIGISL(IG,IS,L),IS=1,NNIS),NOTES
            IF (NOPT(2) .EQ. 1)   GO TO 714
            WRITE(JUNIT,2033)   (RIGISL(IG,IS,L),IS=1,NNIS),NOTES
  714    CONTINUE
C
  710 CONTINUE
C
C
C
C              READ CIGIS--EXTRACTION COST AMOUNTS
C
      DO 720 KK=1,8
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)   GO TO 720
         WRITE(JUNIT,2100)  A
  720 CONTINUE
C
      NNIG=NIG+1
      DO 722 IG=1,NNIG
         READ (IUNIT,1030)   (CIGIS(IG,IS),IS=1,NNIS),NOTES
         IF (NOPT(2) .EQ. 1)   GO TO 722
         WRITE(JUNIT,2034)   (CIGIS(IG,IS),IS=1,NNIS),NOTES
  722 CONTINUE
C
C
C              READ--VISL ENVIRONMENTAL COST AMOUNTS
C
      DO 730 KK=1,6
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)   GO TO 730
         WRITE(JUNIT,2100)  A
  730 CONTINUE
C
         DO 734 L=1,NL
            READ (IUNIT,1030)   (VISL(IS,L),IS=1,NNIS),NOTES
            IF (NOPT(2) .EQ. 1)   GO TO 734
            WRITE(JUNIT,2034)   (VISL(IS,L),IS=1,NNIS),NOTES
  734    CONTINUE
  750 CONTINUE
C
C
C                      READ RIL--PRICE ELASTICITY OF SUPPLY FOR
C                                FOSSIL FUELS, EVALUATED AT DILSET
C
      DO 752 KK=1,6
         READ (IUNIT,1100)   A
         IF (NOPT(2) .EQ. 1)   GO TO 752
         WRITE(JUNIT,2100)   A
  752 CONTINUE
C
C
      DO 754 L=1,NL
         READ (IUNIT,1020)   (RIL(IS,L),IS=1,NIS),NOTES
         IF (NOPT(2) .EQ. 1)   GO TO 754
         WRITE(JUNIT,2020)   (RIL(IS,L),IS=1,NIS),NOTES
  754 CONTINUE
C
C
C                      READ STISL--RATE OF TECHNOLOGICAL CHANGE
C                                  BY SUPPLY MODE AND REGION
C
      DO 758 KK=1,7
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)   GO TO 758
         WRITE(JUNIT,2100)  A
  758 CONTINUE
C
      DO 760 L=1,NL
         READ (IUNIT,1030)   (STISL(IS,L),IS=1,NNIS),NOTES
         IF (NOPT(2) .EQ. 1)   GO TO 760
         WRITE(JUNIT,2030)   (STISL(IS,L),IS=1,NNIS),NOTES
  760 CONTINUE
C
C
C                  READ BESIL--MINIMUM LEVEL OF SHORT TERM
C                  SUPPLY AND REGION
      DO 768 KK=1,7
         READ (IUNIT,1100)   A
         IF (NOPT(2) .EQ. 1)   GO TO 768
         WRITE(JUNIT,2100)   A
  768 CONTINUE
C
      DO 770 L=1,NL
         READ (IUNIT,1030)   (BESIL(IS,L),IS=1,NNIS),NOTES
         IF (NOPT(2) .EQ. 1)   GO TO 770
         WRITE(JUNIT,2034)   (BESIL(IS,L),IS=1,NNIS),NOTES
  770 CONTINUE
C
C
C              READ ESFIL--INITIAL ENERGY SUPPLY ESTIMATES
C
      DO 772 KK=1,10
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)   GO TO 772
         WRITE(JUNIT,2100)  A
  772 CONTINUE
C
      DO 778 L=1,NL
         READ (IUNIT,1030)   (ESFIL(IS,L),IS=1,NNIS),NOTES
         IF (NOPT(2) .EQ. 1)   GO TO 778
         WRITE(JUNIT,2030)   (ESFIL(IS,L),IS=1,NNIS),NOTES
  778 CONTINUE
C
C ------------------------------------------------
C --  READ NATURAL GAS FLARING RATE PARAMETERS  --
C ------------------------------------------------
C
      DO 220 KK=1,8
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 219,220,219
  219    WRITE(JUNIT,2100)  A
  220 CONTINUE
C
      DO 230 L=1,NL
         READ (IUNIT,1060)   (FLRL(II,L),II=1,3),NOTES,ANOTE
         IF (NOPT(2)-1) 229,230,229
  229    WRITE(JUNIT,2060)   (FLRL(II,L),II=1,3),NOTES,ANOTE
  230 CONTINUE
C
C --------------------------------------------------
C --  READ IN HYDROELECTRIC PARAMETERS BY REGION  --
C --------------------------------------------------
C
      DO 240 KK=1,10
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 239,240,239
  239    WRITE(JUNIT,2100)  A
  240 CONTINUE
C
      DO 250 L=1,NL
         READ (IUNIT,1030) (HYDRO(I,L),I=1,5),NOTES,ANOTE
         IF (NOPT(2)-1) 249,250,249
 249     WRITE(JUNIT,2030) (HYDRO(I,L),I=1,5),NOTES,ANOTE
 250  CONTINUE
C
C  ----------------------------------
C  --  READ SOLAR COST PARAMETERS  --
C  ----------------------------------
C
      DO 380 KK=1,7
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 379,380,379
  379    WRITE(JUNIT,2100)  A
  380 CONTINUE
C
      DO 390 L=1,NL
         READ (IUNIT,1060)  (CSLT(L,NT),NT=1,3),NOTES
         IF (NOPT(2)-1) 389,390,389
  389    WRITE(JUNIT,2060)  (CSLT(L,NT),NT=1,3),NOTES
  390 CONTINUE
C
C
C  --------------------------------
C  --  READ SYNFUEL ADD ON COSTS --
C  --------------------------------
C
      DO 533 KK=1,11
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 372,533,372
  372    WRITE(JUNIT,2100)  A
  533 CONTINUE
C
      DO 534 L=1,NL
         READ (IUNIT,1000) (HCILT(1,L,IT),IT=1,3),(HCILT(2,L,IT),IT=1,3)
     $                     ,NOTES
         IF (NOPT(2)-1) 373,534,373
  373    WRITE(JUNIT,2005) (HCILT(1,L,IT),IT=1,3),(HCILT(2,L,IT),IT=1,3)
     $                     ,NOTES
  534 CONTINUE
C
C  ------------------------------------------
C  --  READ SYNFUEL CONVERSION EFFICIENCY  --
C  ------------------------------------------
C
      READ (IUNIT,1100)  A
      IF (NOPT(2)-1) 391,392,391
  391 WRITE(JUNIT,2100)  A
C
  392 READ (IUNIT,1045)  NOTES,GCI(1),NOTE2,GCI(2)
      IF (NOPT(2)-1) 393,394,393
  393 WRITE(JUNIT,2045)  NOTES,GCI(1),NOTE2,GCI(2)
C
C  -------------------------------------------------
C  --  READ SYNFUEL ELASTICITY CONTROL PARAMETER  --
C  -------------------------------------------------
C
  394 READ (IUNIT,1045)  NOTES,RCI(1),NOTE2,RCI(2)
      IF (NOPT(2)-1) 395,396,395
  395 WRITE(JUNIT,2045)  NOTES,RCI(1),NOTE2,RCI(2)
C
C
C  -----------------------------------------------------
C  --  READ ENERGY SERVICE INPUT-OUTPUT COEFFICIENTS  --
C  -----------------------------------------------------
C
  396 DO 400 KK=1,9
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 399,400,399
  399    WRITE(JUNIT,2100)  A
  400 CONTINUE
C
      DO 410 K=1,NF
         READ (IUNIT,1020)  (GJK(J,K),J=1,NJ),NOTES,ANOTE
         IF (NOPT(2)-1) 409,410,409
  409    WRITE(JUNIT,2025)  (GJK(J,K),J=1,NJ),NOTES,ANOTE
  410 CONTINUE
      READ (IUNIT,1020)  (GJ(J),J=1,NJ),NOTES,ANOTE
      IF (NOPT(2)-1) 411,412,411
  411 WRITE(JUNIT,2025)  (GJ(J),J=1,NJ),NOTES,ANOTE
C
C  -------------------------------------------------
C  --  READ NON-ENERGY INPUT-OUTPUT COEFFICIENTS  --
C  -------------------------------------------------
C
  412 DO 420 KK=1,6
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 419,420,419
  419    WRITE(JUNIT,2100)  A
  420 CONTINUE
C
      DO 430 K=1,NF
         READ (IUNIT,1020)  (HJK(J,K),J=1,NJ),NOTES,ANOTE
         IF (NOPT(2)-1) 429,430,429
  429    WRITE(JUNIT,2025)  (HJK(J,K),J=1,NJ),NOTES,ANOTE
  430 CONTINUE
      READ (IUNIT,1020)  (HJ(J),J=1,NJ),NOTES,ANOTE
      IF (NOPT(2)-1) 431,432,431
  431 WRITE(JUNIT,2025)  (HJ(J),J=1,NJ),NOTES,ANOTE
C
C
C  ---------------------------------------------------
C  --  READ BASE ENERGY SERVICE CONSUMPTION SHARES  --
C  ---------------------------------------------------
C
  432 DO 440 KK=1,7
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 439,440,439
  439    WRITE(JUNIT,2100)  A
  440 CONTINUE
C
      DO 460 L=1,NL
         NK=NKL(L)
         DO 450 K=1,NK
           READ (IUNIT,1030) (SJKLP(J,K,L),J=1,NJ),BSKL(K,L),NOTES,ANOTE
           IF (NOPT(2)-1) 449,450,449
  449      WRITE(JUNIT,2030) (SJKLP(J,K,L),J=1,NJ),BSKL(K,L),NOTES,ANOTE
  450    CONTINUE
  460 CONTINUE
C
C ---------------------------------------------------------------------
C -- READ LOGIT FUNCTION WEIGHTS AND SECTORAL ENERGY SERVICE DEMANDS --
C ---------------------------------------------------------------------
C
      DO 468 M=1,NMREAD
         DO 462 KK=1,7
            READ (IUNIT,1100)  A
            IF (NOPT(2)-1) 461,462,461
  461       WRITE(JUNIT,2100)  A
  462    CONTINUE
C
      DO 466 L=1,NL
         NK=NKL(L)
         DO 465 K=1,NK
            READ (IUNIT,1020) (BSJKLM(J,K,L,M),J=1,NJ),NOTES,ANOTE
            IF (NOPT(2)-1) 464,465,464
  464       WRITE(JUNIT,2025) (BSJKLM(J,K,L,M),J=1,NJ),NOTES,ANOTE
  465    CONTINUE
  466 CONTINUE
  468 CONTINUE
C
C  --------------------------------------
C  --  READ OECD END-USE ELASTICITIES  --
C  --------------------------------------
C
      DO 470 KK=1,6
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 471,470,471
  471    WRITE(JUNIT,2100)  A
  470 CONTINUE
C
      DO 480 K=1,NKMAX
         READ (IUNIT,1030) RPKK(K),(RPJK(J,K),J=1,NJ),NOTES,ANOTE
         IF (NOPT(2)-1) 479,480,479
  479    WRITE(JUNIT,2030) RPKK(K),(RPJK(J,K),J=1,NJ),NOTES,ANOTE
  480 CONTINUE
C
      DO 490 KK=1,2
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 489,490,489
  489    WRITE(JUNIT,2100)  A
  490 CONTINUE
C
      READ (IUNIT,1030) RPK,(RPJ(J),J=1,NJ),NOTES,ANOTE
      IF (NOPT(2)-1) 498,499,498
  498 WRITE(JUNIT,2030) RPK,(RPJ(J),J=1,NJ),NOTES,ANOTE
C
  499 DO 500 KK=1,4
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 501,500,501
  501    WRITE(JUNIT,2100)  A
  500 CONTINUE
C
      DO 510 K=1,NKMAX
         READ (IUNIT,1030) RYKK(K),(RYJK(J,K),J=1,NJ),NOTES,ANOTE
         IF (NOPT(2)-1) 509,510,509
  509    WRITE(JUNIT,2030) RYKK(K),(RYJK(J,K),J=1,NJ),NOTES,ANOTE
  510 CONTINUE
C
      DO 520 KK=1,2
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 519,520,519
  519    WRITE(JUNIT,2100)  A
  520 CONTINUE
C
      READ (IUNIT,1020) (RYJ(J),J=1,NJ),NOTES,ANOTE
      IF (NOPT(2)-1) 521,522,521
  521 WRITE(JUNIT,2025) (RYJ(J),J=1,NJ),NOTES,ANOTE
C
  522 DO 481 KK=1,6
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 483,481,483
  483    WRITE(JUNIT,2100)  A
  481 CONTINUE
C
      DO 497 L=1,2
         READ (IUNIT,1080) RYKL(L),NOTES
         IF (NOPT(2)-1) 523,497,523
  523    WRITE(JUNIT,2080) RYKL(L),NOTES
  497 CONTINUE
C
      DO 528 KK=1,3
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 525,528,525
  525    WRITE(JUNIT,2100)  A
  528 CONTINUE
C
      DO 530 L=1,NL
         READ (IUNIT,1080) RYL(L),NOTES
         IF (NOPT(2)-1) 529,530,529
  529    WRITE(JUNIT,2080) RYL(L),NOTES
  530 CONTINUE
C
C
C -----------------------------------------
C --  READ IN CARBON RELEASE PARAMETERS  --
C -----------------------------------------
C
      DO 531 KK=1,7
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 532,531,532
  532    WRITE(JUNIT,2100)  A
  531 CONTINUE
C
      KK=NCO2-1
      READ (IUNIT,1095)  (COI(I),I=1,KK),ANOTE
      IF (NOPT(2)-1) 548,547,548
  548 WRITE(JUNIT,2095)  (COI(I),I=1,KK),ANOTE
C
C  -----------------------------------
C  --  READ GAS FLARING PARAMETERS  --
C  -----------------------------------
C
  547 DO 550 KK=1,7
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 549,550,549
  549    WRITE(JUNIT,2100)  A
  550 CONTINUE
C
      DO 560 L=1,NL
         READ (IUNIT,1000)  (SBURNL(L,IT),IT=1,3),(SHALE(L,IT),IT=1,3),
     $                      NOTES
        IF (NOPT(2)-1) 559,560,559
  559    WRITE(JUNIT,2005)  (SBURNL(L,IT),IT=1,3),(SHALE(L,IT),IT=1,3),
     $                      NOTES
  560 CONTINUE
C
C
C  ---------------------------------
C  --  READ FEEDSTOCK PARAMETERS  --
C  ---------------------------------
C
      DO 570 KK=1,6
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 569,570,569
  569    WRITE(JUNIT,2100)  A
  570 CONTINUE
C
      DO 580 L=1,NL
         READ (IUNIT,1060)  (SFEDIL(I,L),I=1,NF),NOTES
         IF (NOPT(2)-1) 579,580,579
  579    WRITE(JUNIT,2060)  (SFEDIL(I,L),I=1,NF),NOTES
  580 CONTINUE
C
C
C  ---------------------------------
C  --  READ BIOMASS COEFFICIENTS  --
C  ---------------------------------
C
      DO 590 KK=1,13
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 589,590,589
  589    WRITE(JUNIT,2100)  A
  590 CONTINUE
C
      DO 600 IP=1,NIP
         READ (IUNIT,1020)  (BIOPSM(IP,1,IM),BIOPSM(IP,2,IM),IM=1,NIM),
     $                      NOTES
         IF (NOPT(2)-1) 599,600,599
  599    WRITE(JUNIT,2025)  (BIOPSM(IP,1,IM),BIOPSM(IP,2,IM),IM=1,NIM),
     $                      NOTES
  600 CONTINUE
C
      DO 610 KK=1,3
         READ (IUNIT,1100)  A
         IF (NOPT(2)-1) 609,610,609
  609    WRITE(JUNIT,2100)  A
  610 CONTINUE
C
      DO 620 L=1,NL
         READ (IUNIT,1040)  (BIOLM(L,IM),IM=1,NIM),NOTES
         IF (NOPT(2)-1) 619,620,619
  619    WRITE(JUNIT,2042)  (BIOLM(L,IM),IM=1,NIM),NOTES
  620 CONTINUE
C
      DO 931 KK=1,3
         READ (IUNIT,1100)  A
         IF (NOPT(2) .EQ. 1)  GO TO 931
         WRITE(JUNIT,2100)  A
  931 CONTINUE
C
      READ (IUNIT,1080) RYSHT,NOTES
      IF (NOPT(2) .EQ. 1)  GO TO 932
      WRITE(JUNIT,2080) RYSHT,NOTES
  932 CONTINUE
C--------READ DISPOSABLE ORGANIC CARBON
          DO 630 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 628,630,628
 628           WRITE (JUNIT,2100) A
 630      CONTINUE
C
          DO 635 L=1,NL
               READ (IUNIT,1070) (SDOCLM(L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 633,635,633
 633           WRITE (JUNIT,2071) (SDOCLM(L,M),M=1,NMREAD),ANOTE
 635      CONTINUE
C
C---READ CH4 EMISSIONS COEFFICIENTS
C
          DO 640 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 638,640,638
 638           WRITE (JUNIT,2100) A
 640      CONTINUE
C
          READ (IUNIT,1096) (CHI(I),I=1,5), ANOTE
          IF (NOPT(2)-1) 643,645,643
 643      WRITE (JUNIT,2097) (CHI(I),I=1,5),ANOTE
C
 645      DO 1650 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 1648,1650,1648
1648           WRITE (JUNIT,2100) A
1650      CONTINUE
C
C
          DO 1655 L=1,NL
               READ (IUNIT,1070) (CHILM(1,L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 1653,1655,1653
1653           WRITE (JUNIT,2071)(CHILM(1,L,M),M=1,NMREAD),ANOTE
1655      CONTINUE
C
          DO 1660 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 1658,1660,1658
1658           WRITE (JUNIT,2100) A
1660      CONTINUE
C
          DO 1665 L=1,NL
               READ (IUNIT,1070) (CHILM(2,L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 1663,1665,1663
1663           WRITE (JUNIT,2071)(CHILM(2,L,M),M=1,NMREAD),ANOTE
1665      CONTINUE
C
C
C----READ SHARE OF AUTO EXHAUSTS
C
          DO 650 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 648,650,648
 648           WRITE (JUNIT,2100) A
 650      CONTINUE
C
          DO 655 L=1,NL
               READ (IUNIT,1070) (SAXLM(L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 653,655,653
 653           WRITE (JUNIT,2071)(SAXLM(L,M),M=1,NMREAD),ANOTE
 655      CONTINUE
C
C-----READ SHARE OF GAS LEAKAGE IN TRANSMISSION
C
          DO 660 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 658,660,658
 658           WRITE (JUNIT,2100) A
 660      CONTINUE
C
          DO 665 L=1,NL
               READ (IUNIT,1070) (SGAST(L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 663,665,663
 663           WRITE (JUNIT,2071)(SGAST(L,M),M=1,NMREAD),ANOTE
 665      CONTINUE
C
C----READ SHARE OF GAS LOST IN PRODUCTION
C
          DO 670 KK=1,4
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 668,670,668
 668           WRITE (JUNIT,2100) A
 670      CONTINUE
C
          DO 675 L=1,NL
               READ(IUNIT,1070) (SGASP(L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 673,675,673
 673           WRITE (JUNIT,2071) (SGASP(L,M),M=1,NMREAD),ANOTE
 675      CONTINUE
C
C----READ SHARE OF WASTE RESIDUE TO LANDFILL
C
          DO 680 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 678,680,678
 678           WRITE (JUNIT,2100) A
 680      CONTINUE
C
          DO 685 L=1,NL
               READ (IUNIT,1070) (SLDFLM(L,M),M=1,NMREAD),ANOTE
               IF (NOPT(2)-1) 683,685,683
 683           WRITE (JUNIT,2071)(SLDFLM(L,M),M=1,NMREAD),ANOTE
 685      CONTINUE
C
C----READ PRICE ELASTICITY OF TRADITIONAL BIOMASS
C
          DO 690 KK=1,3  
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 688,690,688
 688           WRITE (JUNIT,2100) A
 690      CONTINUE
C
          DO 695 L=1,NL
               READ (IUNIT,1080) RPBIOL(L),NOTES
               IF (NOPT(2)-1) 693,695,693
 693           WRITE (JUNIT,2080)RPBIOL(L),NOTES
 695      CONTINUE
C
C---READ CONVERSION COEFFICIENT FOR LANDFILL ENERGY TO MASS
C
          DO 800 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 698,800,698
 698           WRITE (JUNIT,2100) A
 800      CONTINUE
C
          READ (IUNIT,1080) CLDF,NOTES
               IF (NOPT(2)-1) 803,805,803
 803           WRITE (JUNIT,2080) CLDF,NOTES
C
C---READ INCOME ELASTICITY OF TRADITIONAL BIOMASS
C
805       DO 810 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 808,810,808
 808           WRITE (JUNIT,2100) A
 810      CONTINUE
C
          DO 815 L=1,NL
               READ (IUNIT,1080) RYBIOL(L),NOTES
               IF (NOPT(2)-1) 813,815,813
 813           WRITE (JUNIT,2080) RYBIOL(L),NOTES
 815      CONTINUE
C
C------READ INITIAL STOCK OF TRADITIONAL BIOMASS
C
          DO 820 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 818,820,818
 818           WRITE (JUNIT,2100) A
 820      CONTINUE
C
          DO 825 L=1,NL
               READ (IUNIT,1080) EBIOL(L),NOTES
               IF (NOPT(2)-1) 823,825,823
 823           WRITE (JUNIT,2080) EBIOL(L),NOTES
 825      CONTINUE
C
C---READ SHARE OF WASTE TO LANDFILL
C
          DO 830 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 828,830,828
 828           WRITE (JUNIT,2100) A
 830      CONTINUE
C
          DO 835 L=1,NL
               READ (IUNIT,1080) SWASL(L),NOTES
               IF (NOPT(2)-1) 833,835,833
 833           WRITE (JUNIT,2080) SWASL(L),NOTES
 835      CONTINUE
C
C---READ SHARE OF NONMARKETED GAS VENTED
C
          DO 840 KK=1,3
               READ (IUNIT,1100) A
               IF (NOPT(2)-1) 838,840,838
 838           WRITE (JUNIT,2100) A
 840      CONTINUE
C
          DO 845 L=1,NL
               READ (IUNIT,1060) (SVENTL(L,IT),IT=1,3),NOTES
               IF (NOPT(2)-1) 843,845,843
 843           WRITE (JUNIT,2060) (SVENTL(L,IT),IT=1,3),NOTES
 845      CONTINUE
C
      JUNIT=0
C
      RETURN
      END
