$NOFLOATCALLS
C***********************************************************************
C
      SUBROUTINE OUTPUT
C
C***********************************************************************
C
C             -- THE OUTPUT FORMAT AND CONTROL MODULE --
C
C THIS SUBROUTINE PRINTS ENERGY QUANTITY OUTPUTS FOR THE WORLD AND
C                       REGIONS FOR PERIOD M
C
C INTEGER INPUTS: M, NF, NFF, NI, NJ, NKKL, NKKMAX, NL
C
C REAL INPUTS:    EDIKL, EDIL, EDKL, EDI, EDL, ED, EDRIL, EFJKL, EFJL,
C                 EFKL, EF, EFJ, EFL,ES,ESIL, ESIL1, ESIL2, ESI, ESL,
C                 EX, EXIL, EXI, EXL
C
C SUBROUTINES CALLED: NONE
C
C WRITTEN BY:
C   JAE EDMONDS                        LATEST REVISION:
C   1 JANUARY 1982                      1 JANUARY 1982
C                                      8 SEPT 88 TO INCLUDE COMMON
C***********************************************************************
C
C  MAKE ALL REAL VARIABLES DOUBLE PRECISION
C
      IMPLICIT   REAL*8 (A-H,O-Z),   INTEGER (I-N)
C
C COMMON BLOCKS
C
$INCLUDE:'COMMON.FOR'
C
C--LOCAL PARAMETERS
C
      INTEGER R(33),T(30),SEC(40)
C
      R(1)='USA '
      R(2)='    '
      R(3)='    '
      R(4)='CANA'
      R(5)='DA &'
      R(6)=' EUR'
      R(7)='OECD'
      R(8)=' PAC'
      R(9)='IFIC'
      R(10)='USSR'
      R(11)='/E. '
      R(12)='EUR.'
      R(13)='CHIN'
      R(14)='A/ET'
      R(15)='.AL.'
      R(16)='MIDD'
      R(17)='LE E'
      R(18)='AST '
      R(19)='AFRI'
      R(20)='CA  '
      R(21)='    '
      R(22)='LATI'
      R(23)='N AM'
      R(24)='ER  '
      R(25)='S.&E'
      R(26)='. AS'
      R(27)='IA  '
      R(28)='ALL '
      R(29)='REGI'
      R(30)='ONS '
      R(31)='TOTA'
      R(32)='L TR'
      R(33)='ADE '
C
      T(1)='CON'
      T(2)='VEN'
      T(3)='TIO'
      T(4)='NAL'
      T(5)='   '
      T(6)='UNC'
      T(7)='ONV'
      T(8)='ENT'
      T(9)='ION'
      T(10)='AL '
      T(11)='TOT'
      T(12)='AL '
      T(13)='PRI'
      T(14)='MAR'
      T(15)='Y  ' 
      T(16)='SYN'
      T(17)='FUE'
      T(18)='LS '
      T(19)='   '
      T(20)='   '
      T(21)='TOT'
      T(22)='AL '
      T(23)='SUP'
      T(24)='PLY'
      T(25)='   '
      T(26)='TOT'
      T(27)='AL '
      T(28)='IMP'
      T(29)='ORT'
      T(30)='S  '
C

      SEC(1)='ELE'
      SEC(2)='CTR'
      SEC(3)='IC '
      SEC(4)='POW'
      SEC(5)='ER '
      SEC(6)='RES'
      SEC(7)='IDE'
      SEC(8)='N-C'
      SEC(9)='OMM'
      SEC(10)='ERC'
      SEC(11)='IND'
      SEC(12)='UST'
      SEC(13)='RIA'
      SEC(14)='L  '
      SEC(15)='   '
      SEC(16)='TRA'
      SEC(17)='NSP'
      SEC(18)='ORT'
      SEC(19)='   '
      SEC(20)='   '
      SEC(21)='END'
      SEC(22)='-US'
      SEC(23)='E D'
      SEC(24)='EMA'
      SEC(25)='ND '
      SEC(26)='TOT'
      SEC(27)='AL '
      SEC(28)='DEM'
      SEC(29)='AND'
      SEC(30)='   '
      SEC(31)='TOT'
      SEC(32)='AL '
      SEC(33)='SUP'
      SEC(34)='PLY'
      SEC(35)='   '
      SEC(36)='NET'
      SEC(37)=' IM'
      SEC(38)='POR'
      SEC(39)='TS '
      SEC(40)='   '
C
C
C   +-------------------------------+
C   |   COLLECT FORMAT STATEMENTS   |
C   +-------------------------------+
C
 2000 FORMAT (1H1)
 2001 FORMAT (1H0,27X,'PRIMARY ENERGY DEMAND TABLE')
 2002 FORMAT (1H0,25X,'REFINABLE ENERGY DEMAND TABLE')
 2003 FORMAT (1H0,53X,'TOTAL',2X,'CONSERV&')
 2004 FORMAT (1X,34X,'REGION:  ',3A4)
 2005 FORMAT (1X,10X,5A3,5(F8.2,2X))
 2006 FORMAT (1X,26X,'(UNITS=EXAJOULES (J*10**18))')
 2007 FORMAT (1H0,18X, 'OIL',6X,'GAS',4X,'SOLIDS',3X,'NUCLEAR',3X,'SOLAR
     &',4X,'HYDRO',4X,'TOTAL')
 2008 FORMAT (1X,14X,7(1X,8('-')))
 2009 FORMAT (1X,5A3,7(F7.2,2X))
 2010 FORMAT (1X)
 2011 FORMAT ('0')
 2012 FORMAT (1X,25X,'SECONDARY ENERGY DEMAND TABLE')
 2013 FORMAT (1X,50X,'PURCHASED',1X,'NONELEC')
 2014 FORMAT (1X,15X,'LIQUIDS',3X,'GASES',4X,'SOLIDS',2X,'ELECTRIC',3X,
     & 'FUELS',4X,'SOLAR',4X,'TOTAL')
 2015 FORMAT (1X,25X,5(' -------- '))
 2016 FORMAT (1X,15X,'PRIMARY ENERGY DEMAND SUMMARY, BY REGION AND TYPE'
     &)
 2018 FORMAT (1X,15X,'PRIMARY ENERGY SUPPLY SUMMARY, BY REGION AND TYPE'
     &)
 2019 FORMAT (1H0,23X,'IMPORT SUMMARY, BY REGION AND TYPE')
 2020 FORMAT (1X,3A4,1X,7(1X,F8.2))
 2021 FORMAT (1H0)
 2022 FORMAT (1X,24X,4(3X,8('-')))
 2023 FORMAT (1X,9X,3A4,3X,4(3X,F8.2))
 2024 FORMAT (1X,29X,'OIL',8X,'GAS',7X,'TOTAL',6X,'SOLIDS')
 2025 FORMAT (1X,20X,I4,' ENERGY PRODUCTION AND USAGE REPORT'/
     &       1X,20X,39('*')/)
 2026 FORMAT (1H0,30X,'ENERGY SUPPLY TABLE')
 2030 FORMAT (1X,5A3,3(F7.2,2X),3('     N/A '),F7.2)
 2033 FORMAT (1X,8X,3A4,9X,5(F8.2,2X))
 2034 FORMAT(1X,14X,'REFINABLE ENERGY DEMAND SUMMARY, BY REGION AND TYPE
     &')
 2035 FORMAT(1X,14X,'REFINABLE ENERGY SUPPLY SUMMARY, BY REGION AND TYPE
     &')
 2036 FORMAT(1H0,17X,I4,1X,'ENERGY USE PER DOLLAR GNP AND PER CAPITA'/
     &       1X,17X,45('*')//)
 2037 FORMAT(1H0,3X,'REGION',5X,'POPUL.',1X,'BASE GNP FINAL GNP',1X,
     &'ENERGY USE',3X,'E/GNP',4X,'E/CAPITA',3X,'GNP/CAP'/1X,14X,
     &'(MIL)',2X,'(BIL 1975 US DOL)',1X,'(EXAJOULES)',1X,'J*10**6/$',1X,
     &'J*10**9/CAP',2X,'$/CAP')
 2038 FORMAT(1X,12('-'),1X,7('-'),1X,17('-'),1X,11('-'),1X,9('-'),1X,
     &11('-'),1X,7('-'))
 2039 FORMAT(1X,3A4,1X,F7.0,2(2X,F7.0),2X,F8.2,4X,F8.2,2X,F8.2,3X,F7.0)
 2040 FORMAT(1X,17X,'ELECTRICITY DEMAND SUMMARY, BY REGION AND TYPE')
 2041 FORMAT(1X,17X,'ELECTRICITY SUPPLY SUMMARY, BY REGION AND TYPE')
 2042 FORMAT(1X,17X,'SYNFUEL PRODUCTION SUMMARY, BY REGION AND TYPE')
 2043 FORMAT(1X,15X,'UNITS=EXAJOULES (J*10**18) OF PRIMARY EQUIVALENTS'
     &)
 2044 FORMAT(1X,17X,'UNITS=EXAJOULES (J*10**18) OF HEAT EQUIVALENTS')
 2045 FORMAT (1X,29X,'OIL',8X,'GAS',8X,'COAL',6X,'TOTAL')
 2046 FORMAT (1H0,24X, 'OIL       GAS     SOLIDS    NUCLEAR    SOLAR
     & HYDRO     TOTAL')
 2047 FORMAT(1H0,16X,'REFINABLE OIL SUPPLY SUMMARY BY REGION AND TYPE')
 2048 FORMAT(1X,28X,'CONVEN-',3X,'UNCONVEN-'/1X,28X,'TIONAL',5X,
     &'TIONAL',5X,'SYNOIL',5X,'TOTAL ')
 2049 FORMAT(1H0,16X,'REFINABLE GAS SUPPLY SUMMARY BY REGION AND TYPE')
 2050 FORMAT(1X,28X,'CONVEN-',3X,'UNCONVEN-'/1X,28X,'TIONAL',5X,
     &'TIONAL',5X,'SYNGAS',5X,'TOTAL')
 2051 FORMAT(1H0,15X,'REFINABLE SOLIDS SUPPLY SUMMARY BY REGION AND TYPE
     &')
 2052 FORMAT(1X,36X,'COAL',7X,'BIOMASS',5X,'TOTAL')
 2053 FORMAT(1X,14X,3A4,4X,3(4X,F8.2))
 2054 FORMAT(1X,30X,3(4X,8('-')))
 2055 FORMAT (1H0,27X,'LIQUIDS    GASES     SOLIDS   ELECTRIC    TOTAL')
C
C
C--SET INTERNAL CONTROL PARAMETERS
C
      NKD=NKKMAX+1
      NKS=NKD+1
      NKX=NKS+1
      NLL=NL+1
      NYR=1950+NJUMP*M
      NNF=NF+1
      LC=1+3*(NL)
      LD=LC+2
      LE=1+3*(NLL)
      LF=LE+2
      KC=1+5*NKKMAX
      KD=KC+4
      KE=1+5*NKD
      KF=KE+4
C
C -- OUTPUT OPTION CONTROL
C
      IF(NOPT(5)-1) 15,115,15
C
   15 CONTINUE
C
C--BEGIN PRINTING OUTPUT
C
      DO 110 L=1,NL
C
      LA=1+3*(L-1)
      LB=LA+2
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2025)   NYR
      WRITE(JUNIT,2004)   (R(LL),LL=LA,LB)
      WRITE(JUNIT,2026)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)   (T(KT),KT= 1, 5),(ESIL1M(I,L,M),I=1,NF),
     $                    (ESIL(I,L),I=NNF,NI),ESL1M(L,M)
      WRITE(JUNIT,2030)   (T(KT),KT= 6,10),(ESIL2M(I,L,M),I=1,NF),
     &                    ESL2M(L,M)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)   (T(KT),KT=11,15),(ESIL(I,L),I=1,NI),ESLM(L,M)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2009)   (T(KT),KT=16,20), (SYNILM(I,L,M),I=1,NI),
     &                    SYNLM(L,M)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)   (T(KT),KT=21,25), (ESRILM(I,L,M),I=1,NI),
     &                    ESRLM(L,M)
C
C   +-------------------------------+
C   |   WRITE OUT PRIMARY DEMANDS   |
C   +-------------------------------+
C
      WRITE(JUNIT,2001)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)   (SEC(KK),KK=1,5),(EDIKL(I,1,L),I=1,NI),
     &                    EDKL(1,L)
         IF (NKKL(L)-2)   40,30,40
   30 WRITE(JUNIT,2009)   (SEC(KK),KK=KC,KD),(EDIKL(I,2,L),I=1,NI),
     &                    EDKL(2,L)
      GO TO 60
   40 DO 50 K=2,NKKMAX
         KA=1+5*(K-1)
         KB=KA+4
         WRITE(JUNIT,2009)   (SEC(KK),KK=KA,KB),(EDIKL(I,K,L),I=1,NI),
     &                       EDKL(K,L)
   50 CONTINUE
C
   60 CONTINUE
C
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)  (SEC(KK),KK=KE,KF),(EDIL(I,L),I=1,NI),EDLM(L,M)
C
C   +---------------------------------+
C   |   WRITE OUT REFINABLE DEMANDS   |
C   +---------------------------------+
C
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2002)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)   (SEC(KK),KK=1,5),(EDRIKL(I,1,L),I=1,NI),
     &                    EDRKLM(1,L,M)
         IF (NKKL(L)-2)   240,230,240
  230 WRITE(JUNIT,2009)   (SEC(KK),KK=KC,KD),(EDRIKL(I,2,L),I=1,NI),
     &                    EDRKLM(2,L,M)
      GO TO 260
  240 DO 250 K=2,NKKMAX
         KA=1+5*(K-1)
         KB=KA+4
         WRITE(JUNIT,2009)   (SEC(KK),KK=KA,KB),(EDRIKL(I,K,L),I=1,NI),
     &                       EDRKLM(K,L,M)
  250 CONTINUE
C
  260 CONTINUE
      WRITE(JUNIT,2008)
C
      WRITE(JUNIT,2009)  (SEC(KK),KK=KE,KF),(EDRIL(I,L),I=1,NI),
     &                     EDRLM(L,M)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2009)  (SEC(KK),KK=31,35),(ESRILM(I,L,M),I=1,NI),
     &                   ESRLM(L,M)
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2009)  (SEC(KK),KK=36,40),(EXIL(I,L),I=1,NI),EXLM(L,M)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------+
C   |   WRITE OUT SECONDARY ENERGY DEMANDS   |
C   +----------------------------------------+
C
      WRITE(JUNIT,2011)
      WRITE(JUNIT,2012)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2055)
      WRITE(JUNIT,2015)
      IF (NKKL(L)-2)   80,70,80
   70 WRITE(JUNIT,2005)   (SEC(KK),KK=KC,KD),(EFJKL(J,2,L),J=1,NJ),
     &                    EFKL(2,L)
      GO TO 100
C
   80 DO 90 K=2,NKKMAX
         KA=1+5*(K-1)
         KB=KA+4
         WRITE(JUNIT,2005)   (SEC(KK),KK=KA,KB),(EFJKL(J,K,L),J=1,NJ),
     &                       EFKL(K,L)
   90 CONTINUE
C
  100 CONTINUE
      WRITE(JUNIT,2015)
C
      WRITE(JUNIT,2005)    (SEC(KK),KK=KE,KF),(EFJL(J,L),J=1,NJ),
     &                     EFLM(L,M)
C
C
  110 CONTINUE
C
  115 CONTINUE
C
C -- OUTPUT OPTION CONTROL
C
      IF(NOPT(6)-1) 99,101,99
C
   99 CONTINUE
C
C   +---------------------------------------------+
C   |   WRITE OUT SUMMARY OF ENERGY USE PATTERN   |
C   +---------------------------------------------+
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2025)   NYR
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2016)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 120 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)   (R(LL),LL=LA,LB),(EDIL(I,L),I=1,NI),
     &                       EDLM(L,M)
  120 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(EDIM(I,M),I=1,NI),EDM(M)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------------+
C   |   CONTINUE BY WRITING OUT SUPPLY PATTERN SUMMARY   |
C   +----------------------------------------------------+
C
      WRITE(JUNIT,2018)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 130 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)   (R(LL),LL=LA,LB),(ESIL(I,L),I=1,NI),
     &                       ESLM(L,M)
  130 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(ESIM(I,M),I=1,NI),ESM(M)
      WRITE(JUNIT,2021)
C
C   +----------------------------------------------+
C   |   PRINTOUT SECONDARY ENERGY DEMAND SUMMARY   |
C   +----------------------------------------------+
C
      WRITE(JUNIT,2012)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2003)
      WRITE(JUNIT,2013)
      WRITE(JUNIT,2014)
      WRITE(JUNIT,2008)
      DO 150 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)   (R(LL),LL=LA,LB),(EFJL(J,L),J=1,NJ),
     &                       EFLM(L,M),CONLM(L,M),CEFLM(L,M)
  150 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(EFJM(J,M),J=1,NJ),EFM(M),
     &                    CONM(M),CEFM(M)
      WRITE(JUNIT,2021)
C
C   +---------------------------------------------------+
C   |   WRITE OUT REFINABLE ENERGY DEMAND SUMMARY       |
C   +---------------------------------------------------+
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2025)   NYR
      WRITE(JUNIT,2034)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 200 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)  (R(LL),LL=LA,LB),(EDRIL(I,L),I=1,NI),
     &                      EDRLM(L,M)
  200 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(EDRIM(I,M),I=1,NI),EDRM(M)
      WRITE(JUNIT,2021)
C
C   +-----------------------------------------------+
C   |   WRITE OUT REFINABLE ENERGY SUPPLY SUMMARY   |
C   +-----------------------------------------------+
C
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2035)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 210 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)  (R(LL),LL=LA,LB),(ESRILM(I,L,M),I=1,NI),
     &                       ESRLM(L,M)
  210 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(ESRIM(I,M),I=1,NI),ESRM(M)
      WRITE(JUNIT,2021)
C
C   +-------------------------------------------+
C   |   WRITE OUT REFINABLE OIL SUPPLY SUMMARY  |
C   +-------------------------------------------+
C
      WRITE(JUNIT,2047)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2048)
      WRITE(JUNIT,2022)
      DO 331 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2023)   (R(LL),LL=LA,LB),ESIL1M(1,L,M),
     &                       ESIL2M(1,L,M),SYNILM(1,L,M),ESRILM(1,L,M)
  331 CONTINUE
      WRITE(JUNIT,2022)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2023)   (R(LL),LL=LC,LD),ESI1M(1,M),ESI2M(1,M),
     &                    SYNIM(1,M),ESRIM(1,M)
      WRITE(JUNIT,2021)
C
C   +-------------------------------------------+
C   |   WRITE OUT REFINABLE GAS SUPPLY SUMMARY  |
C   +-------------------------------------------+
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2025)  NYR
      WRITE(JUNIT,2049)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2050)
      WRITE(JUNIT,2022)
      DO 330 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2023)   (R(LL),LL=LA,LB),ESIL1M(2,L,M),
     &                       ESIL2M(2,L,M),SYNILM(2,L,M),ESRILM(2,L,M)
  330 CONTINUE
      WRITE(JUNIT,2022)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2023)   (R(LL),LL=LC,LD),ESI1M(2,M),ESI2M(2,M),
     &                    SYNIM(2,M),ESRIM(2,M)
      WRITE(JUNIT,2021)
C
C   +--------------------------------------------+
C   | WRITE OUT REFINABLE SOLIDS SUPPLY SUMMARY  |
C   +--------------------------------------------+
C
      WRITE(JUNIT,2051)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2052)
      WRITE(JUNIT,2054)
      DO 332 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2053)   (R(LL),LL=LA,LB),ESRL1M(L,M),
     &                       ESRL2M(L,M),ESRILM(3,L,M)
  332 CONTINUE
      WRITE(JUNIT,2054)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2053)   (R(LL),LL=LC,LD),ESR1M(M),ESR2M(M),ESRIM(3,M)
      WRITE(JUNIT,2021)
C
C   +------------------------------------------+
C   |   WRITE OUT NET ENERGY IMPORTS SUMMARY   |
C   +------------------------------------------+
C
      WRITE(JUNIT,2019)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2045)
      WRITE(JUNIT,2022)
      DO 140 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2023)   (R(LL),LL=LA,LB),(EXIL(I,L),I=1,NF),
     &                       EXLM(L,M)
  140 CONTINUE
      WRITE(JUNIT,2022)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2023)   (R(LL),LL=LE,LF),(EXIM(I,M),I=1,NF),EXM(M)
C
C   +------------------------------------------+
C   |   WRITE OUT ELECTRICITY DEMAND SUMMARY   |
C   +------------------------------------------+
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2025)   NYR
      WRITE(JUNIT,2040)
      WRITE(JUNIT,2043)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 300 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)  (R(LL),LL=LA,LB),(EDRIKL(I,1,L),I=1,NI),
     &                      EDRKLM(1,L,M)
  300 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(EDRIKM(I,M),I=1,NI),EDRKM(M)
      WRITE(JUNIT,2021)
C
C      --------------------------------------------
C      --  WRITE OUT ELECTRICITY SUPPLY SUMMARY  --
C      --------------------------------------------
C
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2041)
      WRITE(JUNIT,2044)
      WRITE(JUNIT,2007)
      WRITE(JUNIT,2008)
      DO 310 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2020)  (R(LL),LL=LA,LB),(ESUILM(I,L,M),I=1,NI),
     $                      ESULM(L,M)
  310 CONTINUE
      WRITE(JUNIT,2008)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2020)   (R(LL),LL=LC,LD),(ESUIM(I,M),I=1,NI),ESUM(M)
      WRITE(JUNIT,2021)
C
C      --------------------------------------------
C      --  WRITE OUT SYNFUEL PRODUCTION SUMMARY  --
C      --------------------------------------------
C
      WRITE(JUNIT,2042)
      WRITE(JUNIT,2006)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2024)
      WRITE(JUNIT,2022)
      DO 320 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2023)   (R(LL),LL=LA,LB),(SYNILM(I,L,M),I=1,NFF),
     &                       SYNLM(L,M),SYNILM(NF,L,M)
  320 CONTINUE
      WRITE(JUNIT,2022)
      WRITE(JUNIT,2010)
      WRITE(JUNIT,2023)  (R(LL),LL=LC,LD),(SYNIM(I,M),I=1,NFF),
     &                   SYNM(M),SYNIM(NF,M)
C
C       ----------------------------------------------------------
C       --  WRITE OUT ENERGY USE PER CAPITA AND PER DOLLAR GNP  --
C       ----------------------------------------------------------
C
      WRITE(JUNIT,2000)
      WRITE(JUNIT,2036)  NYR
      WRITE(JUNIT,2037)
      WRITE(JUNIT,2038)
      DO 220 L=1,NL
         LA=1+3*(L-1)
         LB=LA+2
         WRITE(JUNIT,2039) (R(LL),LL=LA,LB),ZLXM(L,M),GNPLM(L,M),
     &         GNPFLM(L,M),EDLM(L,M),EPGLM(L,M),EPCLM(L,M),GNPPCM(L,M)
  220 CONTINUE
      WRITE(JUNIT,2038)
      WRITE(JUNIT,2039) (R(LL),LL=LC,LD),ZLXM(NLL,M),GNPLM(NLL,M),
     & GNPFLM(NLL,M),EDM(M),EPGLM(NLL,M),EPCLM(NLL,M),GNPPCM(NLL,M)
C
  101 CONTINUE
C
C     ----------------------------------
C     --  RETURN TO THE MAIN PROGRAM  --
C     ----------------------------------
C
C
      RETURN
      END


