$NOFLOATCALLS
C***********************************************************************
C
      SUBROUTINE  PRICES
C
C***********************************************************************
C
C                  -- ENERGY PRICE PRINTER --
C
C THIS SUBROUTINE PRINTS PRICES AND COSTS OF PRODUCING ENERGY
C
C MODEL VERSION:  A.31.07.84
C
C INTEGER INPUTS: M, NI, NJ, NF, NKL, NKMAX, NL
C REAL INPUTS:    PIM, PIL, PUIL, PJL, PKL, PJKL
C
C
C SUBROUTINES CALLED: NONE
C
C CODED BY:
C     JAE EDMONDS                      LATEST REVISION:
C     1 JANUARY 1982                    31 JULY 1984
C                                       BY:  JAE EDMONDS
C                                       8 SEPT 88 TO INCLUDE COMMON
C 
C  MAKE ALL REAL VARIABLES DOUBLE PRECISION
C
      IMPLICIT   REAL*8 (A-H,O-Z),   INTEGER (I-N)
C
C COMMON BLOCKS
$INCLUDE:'COMMON.FOR'
C
C
C     -- LOCAL VARIABLES --
C
      INTEGER R(30),PF(16),SF(10),REG(3),W(3)
C
C                 +---------------------------+
C                 |  COLLECT DATA STATEMENTS  |
C                 +---------------------------+
C
      R(1)='USA '
      R(2)='    '
      R(3)='    '
      R(4)='CANA'
      R(5)='DA &'
      R(6)=' EUR'
      R(7)='OECD'
      R(8)=' PAC'
      R(9)='IFIC'
      R(10)='USSR'
      R(11)='/E. '
      R(12)='EUR.'
      R(13)='CHIN'
      R(14)='A/ET'
      R(15)='.AL.'
      R(16)='MIDD'
      R(17)='LE E'
      R(18)='AST '
      R(19)='AFRI'
      R(20)='CA  '
      R(21)='    '
      R(22)='LATI'
      R(23)='N AM'
      R(24)='ER  '
      R(25)='S.&E'
      R(26)='. AS'
      R(27)='IA  '
      R(28)='ALL '
      R(29)='REGI'
      R(30)='ONS '
C
      W(1)='WORL'
      W(2)='D   '
      W(3)='    '
C
C
C                 +--------------------------+
C                 |    PRINT PRICE TABLES    |
C                 +--------------------------+
C
C
      NYR=1950 + M*NJUMP
      NLL=NL+1
C
C
C WRITE OUT HEADING
C
      WRITE(JUNIT,2000)   NYR
      WRITE(JUNIT,2001)
C
C WRITE PRIMARY ENERGY PRICES, TOTAL WORLD AND BY REGION
C
      WRITE(JUNIT,2100)
      WRITE(JUNIT,2103)
      WRITE(JUNIT,2104)
      WRITE(JUNIT,2200)
      WRITE(JUNIT,2201)
      WRITE(JUNIT,2500)   W, (PIM(I,M),I=1,NF)
      DO 100 L=1,NL
         NA=1+3*(L-1)
         NB=NA+2
         WRITE(JUNIT,2501)   (R(LL),LL=NA,NB), (PILM(I,L,M),I=1,NI)
  100 CONTINUE
C
C WRITE ELECTRIC UTILITY COSTS BY MODE
C
      WRITE(JUNIT,2101)
      WRITE(JUNIT,2103)
      WRITE(JUNIT,2104)
      WRITE(JUNIT,2200)
      WRITE(JUNIT,2201)
      DO 110 L=1,NL
         NA=1+3*(L-1)
         NB=NA+2
         WRITE(JUNIT,2501)   (R(LL),LL=NA,NB), (PUILM(I,L,M),I=1,NI)
  110 CONTINUE
C
C WRITE SECONDARY ENERGY PRICES
C
      WRITE(JUNIT,2102)
      WRITE(JUNIT,2103)
      WRITE(JUNIT,2104)
      WRITE(JUNIT,2210)
      WRITE(JUNIT,2211)
      DO 120 L=1,NL
         NA=1+3*(L-1)
         NB=NA+2
         WRITE(JUNIT,2502)   (R(LL),LL=NA,NB), (PJLM(J,L,M),J=1,NJ)
  120 CONTINUE
C
C               +---------------------------------+
C               |    COLLECT FORMAT STATEMENTS    |
C               +---------------------------------+
C
C
 2000 FORMAT(1H1,28X,I4,1X,'ENERGY PRICE REPORT')
 2001 FORMAT(1X,28X,24('*')/)
C
 2100 FORMAT(1X,29X,'PRIMARY ENERGY PRICES')
 2101 FORMAT(1X,//1X,24X,'ELECTRIC POWER GENERATION COSTS')
 2102 FORMAT(1X,//1X,28X,'SECONDARY ENERGY PRICES')
 2103 FORMAT(1X,36X,'BY MODE')
 2104 FORMAT(1X,24X,'(1975 U.S. DOLLARS PER GIGAJOULE)')
C
 2200 FORMAT(1X,3X,'REGION',8X,'OIL',7X,'GAS',6X,'SOLIDS',5X,'NUCLEAR',
     &5X,'SOLAR-ELEC',4X,'HYDRO')
 2201 FORMAT(1X,12('-'),2(3X,7('-')),3X,8('-'),4X,7('-'),5X,10('-'),3X,
     &7('-'))
 2210 FORMAT(1X,13X,'REGION',6X,'LIQUIDS',4X,'GASES',6X,'SOLIDS',7X,
     &'ELECTRIC')
 2211 FORMAT(1X,10X,12('-'),2(3X,7('-')),4X,8('-'),6X,8('-'))
C
 2500 FORMAT(1X,3A4,3(3X,F7.2))
 2501 FORMAT(1X,3A4,3(3X,F7.2),5X,F7.2,6X,F7.2,5X,F7.2)
 2502 FORMAT(1X,10X,3A4,2(3X,F7.2),5X,F7.2,6X,F7.2)
C
C
      RETURN
      END




